'use strict';

/**
 *
 */
module.exports = function scaffoldTaskObj (taskPath, args) {

    var
        //
        path = require('path'),

        //
        validateTaskObj = require('./validateTaskObj.js'),

        //
        taskObj;

    //
    try {
        taskObj = require(taskPath);
    } catch (err) {
        throw err;
    }

    //
    if (typeof taskObj === 'function') {

        //
        taskObj = taskObj.apply(null, args);

        //
        if (typeof taskObj === 'undefined') {
            throw new Error();
        }

    }

    //
    if (typeof taskObj === 'undefined') {
        throw new Error();
    }

    //
    try {
        taskObj = validateTaskObj(taskObj);
    } catch (err) {
        throw err;
    }

    //
    taskObj.name = path.basename(taskPath).replace(/\.(coffee|js)$/, '');

    //
    return taskObj;

};
